<?php

namespace Oro\Bundle\SearchBundle\Entity\Repository;

use Doctrine\ORM\EntityRepository;

use Oro\Bundle\SearchBundle\Query\Query;

/**
 * SearchIndexRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class SearchIndexRepository extends EntityRepository
{
    /**
     * @var \Oro\Bundle\SearchBundle\Engine\Orm\BaseDriver
     */
    protected $driverRepo;

    /**
     * @var array
     */
    protected $drivers;

    /**
     * Search query to index
     *
     * @param \Oro\Bundle\SearchBundle\Query\Query $query
     *
     * @return array
     */
    public function search(Query $query)
    {
        return $this->getDriverRepo()->search($query);
    }

    /**
     * Get count of records without limit parameters in query
     *
     * @param \Oro\Bundle\SearchBundle\Query\Query $query
     *
     * @return integer
     */
    public function getRecordsCount(Query $query)
    {
        return $this->getDriverRepo()->getRecordsCount($query);
    }

    /**
     * Set array with additional drivers
     *
     * @param array $drivers
     */
    public function setDriversClasses($drivers)
    {
        $this->drivers = $drivers;
    }

    /**
     * Get driver repository
     *
     * @return \Oro\Bundle\SearchBundle\Engine\Orm\BaseDriver
     */
    protected function getDriverRepo()
    {
        if (!is_object($this->driverRepo)) {
            $config = $this->getEntityManager()->getConnection()->getParams();
            $className = $this->drivers[$config['driver']];

            $this->driverRepo = new $className($config['driver']);
            $this->driverRepo->initRepo($this->_em, $this->_class);
        }

        return $this->driverRepo;
    }
}
